﻿#This is where most declarations are set for The Nettestadt Troll.
#The code is open-sourced for personal use only.
#Do not redistribute the game with modified code unless you have permission from the author.

#The following section contains standard Ren'Py options:
#---------------------------------------------------
init -1:
    python hide:

        config.developer = False
        
        config.screen_width = 800
        config.screen_height = 600

        config.window_title = u"The Nettestadt Troll"
        
        config.window_icon = "nt_icon.png"

        theme.roundrect(

            widget = "#753D00",

            widget_hover = "#B19A48",

            widget_text = "#CCCAC2",

            widget_selected = "#ffffff",

            disabled = "#A2521D",

            disabled_text = "#753D00",

            label = "#ffffff",

            frame = "#797C1C",

            button_menu = True,

            rounded_window = True,

            mm_root = "maintitle.jpg",

            gm_root = im.Sepia("maintitle.jpg")
         
            )

        style.window.background = Frame("frame.png", 12, 12)
        
        style.window.left_margin = 6
        style.window.right_margin = 6
        style.window.top_margin = 6
        style.window.bottom_margin = 6
        
        style.window.left_padding = 6
        style.window.right_padding = 6
        style.window.top_padding = 6
        style.window.bottom_padding = 6

        style.default.font = "ARGOSMF_.TTF"

        style.default.color = "000000"
        style.default.size = 24

        config.has_sound = True

        config.has_music = True

        config.has_voice = False

        style.button.activate_sound = "click.ogg"
        style.imagemap.activate_sound = "click.ogg"

        config.enter_sound = "click.ogg"
        config.exit_sound = "click.ogg"

        config.sample_sound = "click.ogg"

        config.main_menu_music = "towers.ogg"

        config.enter_transition = dissolve

        config.exit_transition = dissolve

        config.intra_transition = dissolve

        config.main_game_transition = dissolve

        config.game_main_transition = dissolve

        config.end_splash_transition = dissolve

        config.end_game_transition = dissolve
        
        config.default_fullscreen = False

        config.default_text_cps = 90
        
#The following section contains my custom declarations:
#---------------------------------------------------
init:
# plain black and white screens
    image black = Solid((0, 0, 0, 255))
    image white = Solid((255, 255, 255, 255))

# upper left, upper right, lower left, lower right quadrants are defined
    $ UL = Position(xpos=0, xanchor=0, ypos = 0, yanchor = 0)
    $ UR = Position(xpos=0, xanchor=800, ypos = 0, yanchor = 0)
    $ LL = Position(xpos=0, xanchor=0, ypos=0, yanchor=600)
    $ LR = Position(xpos=0, xanchor=800, ypos=0, yanchor=600)

# unlike fade, this is not a standard definition
    $ flashbulb = Fade(0.2, 0.0, 0.8, color='#fff')

# --------------------Complex Image Declarations----------------------------------
# splash images

    image dafoollogobase = "dafoollogo.jpg"
    image dafoollogooverlay = "dafoollogo2.png"
    $ dafoollogobasegray = im.Sepia("dafoollogo.jpg")
    image dafoollogoalpha = im.Alpha(dafoollogobasegray, 0.5)
    
    image warning = "warning.png"
    
# event CGs
    image cg1 = "GerhardECG1.jpg"
    image cg2 = "UweECG2.jpg"
    image cg2p = im.Sepia("UweECG2.jpg")
    image cg3 = "JakobECG3.jpg"
    image uhcg1 = "UweHCG1.jpg"
    image uhcg2 = "UweHCG2.jpg"
    image uhcg3 = "UweHCG3.jpg"
    image uhcg4 = "UweHCG4.jpg"
    image jhcg1 = "JakobHCG1.jpg"
    image jhcg2 = "JakobHCG2.jpg"
    image jhcg3 = "JakobHCG3.jpg"
    $ jhcg4base = "JakobHCG3.jpg"
    image jhcg4 = im.Composite((800, 600), (0, 0), jhcg4base, (0, 0), "JakobHCG4.png")
    
# basic day / night images  

    $ nettestadtday = Image("nettestadtcastleday.jpg")
    $ nettestadtnight = Image("nettestadtcastlenight.jpg")
    $ cottageinsideday = Image("cottageinsideday.jpg")
    $ cottageinsidenight = Image("cottageinsidenight.jpg")
    $ cottagefrontday = Image("cottagefrontday.jpg")
    $ cottagefrontnight = Image("cottagefrontnight.jpg")
    $ meadowsday = Image("meadowsday.jpg")
    $ meadowsnight = Image("meadowsnight.jpg")
    $ milltavernday = Image("milltavernday.jpg")
    $ milltavernnight = Image("milltavernnight.jpg")

# dynamic displayables and scaled composites defined and set to a default, the first one is regular size, the S version is 2X

    $ cottageinsider = cottageinsideday
    $ cottageinsiderscalerday = im.Scale(cottageinsideday, 1600, 1200)
    $ cottageinsiderscalernight = im.Scale(cottageinsidenight, 1600, 1200)
    $ cottageinsiderscaler = cottageinsiderscalerday

    image cottageinside = DynamicDisplayable("cottageinsider")
    image cottageinsideS = DynamicDisplayable("cottageinsiderscaler")
            
    $ cottagefronter = cottagefrontday
    $ cottagefronterscalerday = im.Scale(cottagefrontday, 1600, 1200)
    $ cottagefronterscalernight = im.Scale(cottagefrontnight, 1600, 1200)        
    $ cottagefronterscaler = cottagefronterscalerday

    image cottagefront = DynamicDisplayable("cottagefronter")
    image cottagefrontS = DynamicDisplayable("cottagefronterscaler")
    
    $ meadowser = meadowsday
    $ meadowserscalerday = im.Scale(meadowsday, 1600, 1200)
    $ meadowserscalernight = im.Scale(meadowsnight, 1600, 1200)
    $ meadowserscaler = meadowserscalerday
    
    image meadows = DynamicDisplayable("meadowser")
    image meadowsS = DynamicDisplayable("meadowserscaler")
    
    $ milltaverner = milltavernday
    $ milltavernerscalerday = im.Scale(milltavernday, 1600, 1200)
    $ milltavernerscalernight = im.Scale(milltavernnight, 1600, 1200)
    $ milltavernerscaler = milltavernerscalerday

    image milltavern = DynamicDisplayable("milltaverner")
    image milltavernS = DynamicDisplayable("milltavernerscaler")

    $ nettestadter = nettestadtday
    $ nettestadterscalerday = im.Scale(nettestadtday, 1600, 1200)
    $ nettestadterscalernight = im.Scale(nettestadtnight, 1600, 1200)
    $ nettestadterscaler = nettestadterscalerday
    
    image nettestadt = DynamicDisplayable("nettestadter")
    image nettestadtS = DynamicDisplayable("nettestadterscaler")

# cottage front imagemapping

    $ cottagefronthoverlay = Image("cottagefrontarrowhover.png")
    $ cottagefrontbaselay1 = im.Sepia("cottagefrontarrowhover.png")
    $ cottagefrontbaselay = im.Alpha(cottagefrontbaselay1, 0.5)
    $ cottagefrontbasedefday = cottagefrontday
    $ cottagefrontbasedefnight = cottagefrontnight

    $ cottagefrontbaseday = im.Composite((800, 600), (0, 0), cottagefrontbasedefday, (0, 120), cottagefrontbaselay)
    $ cottagefrontbasenight = im.Composite((800, 600), (0, 0), cottagefrontbasedefnight, (0, 120), cottagefrontbaselay)
    $ cottagefronthoverday = im.Composite((800, 600), (0, 0), cottagefrontbasedefday, (0, 120), cottagefronthoverlay)
    $ cottagefronthovernight = im.Composite((800, 600), (0, 0), cottagefrontbasedefnight, (0, 120), cottagefronthoverlay)

# cottage inside imagemapping

    $ cottageinsidehoverlay = Image("cottageinsidearrowhover.png")
    $ cottageinsidebaselay1 = im.Sepia("cottageinsidearrowhover.png")
    $ cottageinsidebaselay = im.Alpha(cottageinsidebaselay1, 0.5)
    $ cottageinsidebasedefday = cottageinsideday
    $ cottageinsidebasedefnight = cottageinsidenight

    $ cottageinsidebaseday = im.Composite((800, 600), (0, 0), cottageinsidebasedefday, (50, 50), cottageinsidebaselay)
    $ cottageinsidebasenight = im.Composite((800, 600), (0, 0), cottageinsidebasedefnight, (50, 50), cottageinsidebaselay)
    $ cottageinsidehoverday = im.Composite((800, 600), (0, 0), cottageinsidebasedefday, (50, 50), cottageinsidehoverlay)
    $ cottageinsidehovernight = im.Composite((800, 600), (0, 0), cottageinsidebasedefnight, (50, 50), cottageinsidehoverlay)

# meadows imagemapping

    $ meadowshoverlay = Image("meadowsarrowhover.png")
    $ meadowsbaselay1 = im.Sepia("meadowsarrowhover.png")
    $ meadowsbaselay = im.Alpha(meadowsbaselay1, 0.5)
    $ meadowsbasedefday = meadowsday
    $ meadowsbasedefnight = meadowsnight
    
    $ meadowsbaseday = im.Composite((800, 600), (0, 0), meadowsbasedefday, (0, 120), meadowsbaselay)
    $ meadowsbasenight = im.Composite((800, 600), (0, 0), meadowsbasedefnight, (0, 120), meadowsbaselay)
    $ meadowshoverday = im.Composite((800, 600), (0, 0), meadowsbasedefday, (0, 120), meadowshoverlay)
    $ meadowshovernight = im.Composite((800, 600), (0, 0), meadowsbasedefnight, (0, 120), meadowshoverlay)    
    
# milltavern imagemapping

    $ milltavernhoverlay = Image("milltavernarrowhover.png")
    $ milltavernbaselay1 = im.Sepia("milltavernarrowhover.png")
    $ milltavernbaselay = im.Alpha(milltavernbaselay1, 0.5)
    $ milltavernbasedefday = milltavernday
    $ milltavernbasedefnight = milltavernnight

    $ milltavernbaseday = im.Composite((800, 600), (0, 0), milltavernbasedefday, (0, 60), milltavernbaselay)
    $ milltavernbasenight = im.Composite((800, 600), (0, 0), milltavernbasedefnight, (0, 60), milltavernbaselay)
    $ milltavernhoverday = im.Composite((800, 600), (0, 0), milltavernbasedefday, (0, 60), milltavernhoverlay)
    $ milltavernhovernight = im.Composite((800, 600), (0, 0), milltavernbasedefnight, (0, 60), milltavernhoverlay)    

# downtown nettestadt imagemapping

    $ nettestadthoverlay = Image("nettestadtarrowhover.png")
    $ nettestadtbaselay1 = im.Sepia("nettestadtarrowhover.png")
    $ nettestadtbaselay = im.Alpha(nettestadtbaselay1, 0.5)
    $ nettestadtbasedefday = nettestadtday
    $ nettestadtbasedefnight = nettestadtnight
    
    $ nettestadtbaseday = im.Composite((800, 600), (0, 0), nettestadtbasedefday, (50, 10), nettestadtbaselay)
    $ nettestadtbasenight = im.Composite((800, 600), (0, 0), nettestadtbasedefnight, (50, 10), nettestadtbaselay)
    $ nettestadthoverday = im.Composite((800, 600), (0, 0), nettestadtbasedefday, (50, 10), nettestadthoverlay)
    $ nettestadthovernight = im.Composite((800, 600), (0, 0), nettestadtbasedefnight, (50, 10), nettestadthoverlay)  

# -------------------Character Sprites----------------------

#Katja sprites           

#base pngs

    $ base = Image("katjabase.png")
    $ curiousbase = Image("katjabasecurious.png")
    $ smilebase = Image("katjabasesmiling.png")
    
#eye pngs

    $ eyenormal = Image( "katjalayeyecurious.png")
    $ eyeshift = Image("katjalayeyeshift.png")
    $ eyeblink = Image("katjalayeyeblinking.png")
    $ eyescared = Image("katjalayeyescared.png")
    $ eyesmile = Image("katjalayeyesmiling.png")
    
#composite curious face 3 states of animation

    $ curious = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), base, (0, 300), curiousbase, (0, 300), eyenormal)
    $ curiousblink = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), base, (0, 300), curiousbase, (0, 300), eyeblink)
    $ curiousshift = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), base, (0, 300), curiousbase, (0, 300), eyeshift)
    
#composite smiling face 3 states of animation

    $ smiling = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), base, (0, 300), smilebase, (0, 300), eyenormal)
    $ smilingblink = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), base, (0, 300), smilebase, (0, 300), eyeblink)
    $ smilingshift = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), base, (0, 300), smilebase, (0, 300), eyeshift)
    
#composite non-animated expressions

    $ scared = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), base, (0, 300), curiousbase, (0, 300), eyescared) 
    
#animated curious

    $ kneutral = Character('Katja', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=anim.SMAnimation( 
    "open", 
    anim.State("open", Image(curious, xalign=0.0, yalign=1.0)), 
    anim.State("close", Image(curiousblink, xalign=0.0, yalign=1.0)), 
    anim.State("shift", Image(curiousshift, xalign=0.0, yalign=1.0)), 
    
    anim.Edge("open", 1.0, "open", prob=4), 
    anim.Edge("shift", 0.3, "shift", prob=2),
    anim.Edge("shift", 0.1, "close"), 
    anim.Edge("open", 0.1, "close"), 
    anim.Edge("close", 0.1, "open") ,
    anim.Edge("close", 0.1, "shift"), 
    )) 
    
#animated smiling    

    $ ksmile = Character('Katja', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=anim.SMAnimation( 
    "open", 
    anim.State("open", Image(smiling, xalign=0.0, yalign=1.0)), 
    anim.State("close", Image(smilingblink, xalign=0.0, yalign=1.0)), 
    anim.State("shift", Image(smilingshift, xalign=0.0, yalign=1.0)), 
    
    anim.Edge("open", 1.0, "open", prob=4), 
    anim.Edge("shift", 0.3, "shift", prob=2),
    anim.Edge("shift", 0.1, "close"), 
    anim.Edge("open", 0.1, "close"), 
    anim.Edge("close", 0.1, "open") ,
    anim.Edge("close", 0.1, "shift"), 
    )) 
    
#non-animated expressions   

    $ kscared = Character('Katja', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(scared, xalign=0.0, yalign=1.0))
                        
    $ kthink = Character(None, color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ kterrified = Character(None, color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20, what_slow_cps=20)
    $ kmono = Character('Katja', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)

#Alfrieda sprites (3 states)

    $ amadimage = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "alfriedabase.png", (0, 300), "alfriedalaymad.png")
    $ amad = Character('Alfrieda', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(amadimage, xalign=0.0, yalign=1.0))
    $ asurpimage = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "alfriedabase.png", (0, 300), "alfriedalaysurprised.png")
    $ asurprised = Character('Alfrieda', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(asurpimage, xalign=0.0, yalign=1.0))
    $ asmileimage = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "alfriedabase.png", (0, 300), "alfriedalaysmiling.png")
    $ asmile = Character('Alfrieda', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(asmileimage, xalign=0.0, yalign=1.0))
                        
#Uwe sprites (2 states)

    $ uuns = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "uwebase.png", (0, 300), "uwelayunsure.png")
    $ u = Character('Uwe', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(uuns, xalign=0.0, yalign=1.0))
                        
    $ udet = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "uwebase.png", (0, 300), "uwelaydet.png")
    $ ud = Character('Uwe', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(udet, xalign=0.0, yalign=1.0))
                        
 #basic and slow mode
    $ umono = Character('Uwe', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ uslow = Character('Uwe', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20, what_slow_cps=20)

 #special sepia flashback version of sprites
    $ upast = im.Sepia(uuns)
    $ up = Character('Uwe', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(upast, xalign=0.0, yalign=1.0))
    $ upast2 = im.Sepia(udet)
    $ upd = Character('Uwe', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(upast2, xalign=0.0, yalign=1.0))

#Gerhard sprites (2 states)

    $ ghap = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "gerhardbase.png", (0, 300), "gerhardlayhappy.png")
    $ g = Character('Gerhard', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(ghap, xalign=0.0, yalign=1.0))
                        
    $ gdist = im.Composite((225, 600), (0, 0), "blank.png", (0,300), "gerhardbase.png", (0, 300), "gerhardlaydisturbed.png")
    $ gd = Character('Gerhard', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(gdist, xalign=0.0, yalign=1.0))
                        
 #basic and slow mode
    $ gmono = Character('Gerhard', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ gslow = Character('Gerhard', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20, what_slow_cps=20)

 #special sepia flashback version of sprites
    $ gpast = im.Sepia(gdist)
    $ gpast2 = im.Sepia(ghap)
    $ gph = Character('Gerhard', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(gpast2, xalign=0.0, yalign=1.0))
    $ gps = Character('Gerhard', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(gpast, xalign=0.0, yalign=1.0))
                        
#Jakob sprites (2 states)

    $ jseri = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "jakobbase.png", (0, 300), "jakoblayserious.png")
    $ j = Character('Jakob', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(jseri, xalign=0.0, yalign=1.0))
                        
    $ jsarc = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "jakobbase.png", (0, 300), "jakoblaysarc.png")
    $ js = Character('Jakob', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(jsarc, xalign=0.0, yalign=1.0))

 #basic and slow mode
    $ jmono = Character('Jakob', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ jslow = Character('Jakob', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20, what_slow_cps=20)

 #special sepia flashback version of sprites
    $ jpast = im.Sepia(jseri)
    $ jp = Character('Jakob', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=Image(jpast, xalign=0.0, yalign=1.0))

#Troll images
#Troll blinking sprite          

    $ tbase = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "trollbase.png")
    $ tblink = im.Composite((225, 600), (0, 0), "blank.png", (0, 300), "trollbase.png", (0, 300), "trollblink.png")
    $ t = Character('Troll', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=230,
                        show_side_image=anim.SMAnimation( 
    "open", 
    anim.State("open", Image(tbase, xalign=0.0, yalign=1.0)), 
    anim.State("close", Image(tblink, xalign=0.0, yalign=1.0)), 

    anim.Edge("open", 1.0, "open", prob=4), 
    anim.Edge("open", 0.15, "close"), 
    anim.Edge("close", 0.15, "open") 
    )) 
    
#Troll event CG
    image trollsurprise = im.Scale("trollbase.png", 500, 667) 

#Other Character Declarations (incidentals without sprites)
    $ bartender = Character('Bartender', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ aunt = Character('Aunt Heidi', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ stranger = Character('Stranger', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ villager = Character('Villager', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ ovillager = Character('Another Villager', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ miller = Character('Miller', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ guard = Character('Guard', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ alchemist = Character('Alchemist', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ baroness = Character('Baroness', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ baron = Character('Baron', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    $ ingrid = Character('Ingrid', color="#000000", ctc=anim.Blink("arrow.png"), window_left_padding=20)
    
#warning and dafool logo intro prior to main menu
label splashscreen:

    $ renpy.pause(0)
    scene black
    show warning at center with dissolve
    $ renpy.pause(4.5)
    hide warning with Dissolve(0.5)
    $ renpy.music.play ("dafoolintropartial.ogg", loop=False)
    scene white
    show dafoollogobase at Position(xpos=80, xanchor=0, ypos=60, yanchor=0)
    with Dissolve(0.2)
    with Pause (1.0)
    hide dafoollogobase
    show dafoollogoalpha at Position(xpos=80, xanchor=0, ypos=60, yanchor=0)
    show dafoollogooverlay at center
    with Dissolve(3.0)
    $ renpy.music.stop(fadeout=2.0)
    with Pause (2.0)
    scene black
    with Dissolve(0.5)
    return

# CG Gallery Code modified from the new version

init:
    $ gallerybutton = im.Composite((155, 112), (0, 0), "galleryframe.png", (53, 47), "arrow.png")
    $ galleryinvert = im.MatrixColor(gallerybutton,
                                       [ -1,  0,  0, 0, 1,
                                          0, -1,  0, 0, 1,
                                          0,  0, -1, 0, 1,
                                          0,  0,  0, 1, 0, ])
    # Position the navigation on the right side of the screen.
    $ style.gallery_nav_frame.xpos = 800 - 10
    $ style.gallery_nav_frame.xanchor = 1.0
    $ style.gallery_nav_frame.ypos = 12

    # Add the gallery to the main menu.
    $ config.main_menu.insert(2, ('Gallery', "gallery", "True"))

# The entry point to the gallery code.
label gallery:
    python hide:

        # Construct a new gallery object.
        g = Gallery()

        # The image used for locked buttons.
        g.locked_button = "galleryframe.png"

        # The background of a locked image.
        g.locked_background = Solid((255, 255, 255, 255))

        # Frames added over unlocked buttons, in hover and idle states.

        g.hover_border = Image(galleryinvert)
        g.idle_border = "galleryframe.png"

        # An images used as the background of the various gallery pages.
        g.background = im.Grayscale("nettestadtcastlenight.jpg")

        # Lay out the gallery images on the screen.
        # These settings lay images out 3 across and 4 down.
        # They expect button images to be 155x112 in size.
        g.grid_layout((3, 1), (10, 12), (160, 124))

        # Show the CG page.
        g.page("CG Gallery")

        # Our first button is a picture of the beach.
        g.button("gallerythumb.jpg")
        #
        # These show images, if they have been unlocked. The image name must
        # have been defined using an image statement.
        g.unlock_image("cg1")
        
        g.button("gallerythumb.jpg")
        g.unlock_image("cg2")
        
        g.button("gallerythumb.jpg")
        g.unlock_image("cg3")
        
        # A second set of images.
        g.button("gallerythumb.jpg")
        
        g.unlock_image("uhcg1")
        g.unlock_image("uhcg2")
        g.unlock_image("uhcg3")
        g.unlock_image("uhcg4")

        g.button("gallerythumb.jpg")
        
        g.unlock_image("jhcg1")
        g.unlock_image("jhcg2")
        g.unlock_image("jhcg3")
        g.unlock_image("jhcg4")

        # Now, show the gallery.
        g.show()
    
    return
    